hdu 4849 Wow! Such City!(最短路)

Wow! Such City!

Problem Description
Doge, tired of being a popular image on internet, is considering moving to another city for a new way of life.
In his country there are N (2 ≤N≤ 1000) cities labeled 0 … N - 1. He is currently in city 0. Meanwhile, for each pair of cities, there exists a road connecting them, costing Ci,j (a positive integer) for traveling from city i to city j. Please note that Ci,j may not equal to Cj,i for any given i ≠ j.
Doge is carefully examining the cities: in fact he will divide cities (his current city 0 is NOT included) into M (2 ≤ M ≤ 106) categories as follow: If the minimal cost from his current city (labeled 0) to the city i is Di, city i belongs to category numbered Di mod M.Doge wants to know the “minimal” category (a category with minimal number) which contains at least one city.
For example, for a country with 4 cities (labeled 0 … 3, note that city 0 is not considered), Doge wants to divide them into 3 categories. Suppose category 0 contains no city, category 1 contains city 2 and 3, while category 2 contains city 1, Doge consider category 1 as the minimal one.
Could you please help Doge solve this problem?

Note:

Ci,j is generated in the following way:
Given integers X0, X1, Y0, Y1, (1 ≤ X0, X1, Y0, Y1≤ 1234567), for k ≥ 2 we have
Xk = (12345 + Xk-1 * 23456 + Xk-2 * 34567 + Xk-1 * Xk-2 * 45678) mod 5837501
Yk = (56789 + Yk-1 * 67890 + Yk-2 * 78901 + Yk-1 * Yk-2 * 89012) mod 9860381
The for k ≥ 0 we have

Zk = (Xk * 90123 + Yk ) mod 8475871 + 1

Finally for 0 ≤ i, j ≤ N - 1 we have

Ci,j = Zi*n+j for i ≠ j
Ci,j = 0 for i = j

Input
There are several test cases. Please process till EOF.
For each test case, there is only one line containing 6 integers N,M,X0,X1,Y0,Y1.See the description for more details.

Output
For each test case, output a single line containing a single integer: the number of minimal category.

Sample Input
3 10 1 2 3 4
4 20 2 3 4 5

Sample Output
1
10

For the first test case, we have

   0       1       2       3       4       5       6       7       8

X 1 2 185180 788997 1483212 4659423 4123738 2178800 219267
Y 3 4 1633196 7845564 2071599 4562697 3523912 317737 1167849
Z 90127 180251 1620338 2064506 625135 5664774 5647950 8282552 4912390

the cost matrix C is
0 180251 1620338
2064506 0 5664774
5647950 8282552 0

Hint
So the minimal cost from city 0 to city 1 is 180251, while the distance to city 2 is 1620338.
Given M = 10, city 1 and city 2 belong to category 1 and 8 respectively.
Since only category 1 and 8 contain at least one city,
the minimal one of them, category 1, is the desired answer to Doge’s question.

ps:比赛时做了一个小时,结果把题意理解错了,真TTTTTT尴尬!

我的思路:最短路之后,记录下到每一点的距离对m取余的数共出现多少次,最后出现次数最多的那个数就是“最短距离“
正解思路:最短路之后,起点到每一点的距离对m取余,余数的大小即“最短距离”

代码:

#include<stdio.h>
#include<queue>
#include<string.h>
#include<algorithm>
using namespace std;

#define mem(a,b) memset(a,b,sizeof(a))
#define min(a,b) (a<b?a:b)
#define maxn 1000+5
#define maxv 1000000+5
const int inf=0x3f3f3f3f;
typedef long long  LL;

LL n,m;
LL dis[maxn][maxn];
LL x[maxv],y[maxv],z[maxv];
LL d[maxn];
bool vis[maxn];

void dijkstra()
{
    LL i,j,minn,v;
    for(i=0; i<n; i++)
    {
        vis[i]=0;
        d[i]=dis[0][i];
    }
    vis[0]=true;
    for(i=0; i<n; i++)
    {
        minn=inf;
        for(j=0; j<n; j++)
            if(!vis[j]&&d[j]<minn)
                minn=d[j],v=j;
        vis[v]=true;
        for(j=0; j<n; j++)
        {
            if(!vis[j]&&d[j]>d[v]+dis[v][j])
                d[j]=d[v]+dis[v][j];
        }
    }
}

void solve()
{
    LL maxx=inf;
    for(LL i=1;i<n;i++)
        maxx=min(maxx,d[i]%m);
    printf("%lld\n",maxx);
}

void init()
{
    LL sum=n*(n-1)+n-1;
    z[0]=(x[0]*90123+y[0])%8475871+1;
    z[1]=(x[1]*90123+y[1])%8475871+1;
    for(LL i=2; i<sum; i++)
    {
        x[i]=(12345+(x[i-1]*23456%5837501)+(x[i-2]*34567%5837501)+(x[i-1]*x[i-2]*45678%5837501))%5837501;
        y[i]=(56789+(y[i-1]*67890%9860381)+(y[i-2]*78901%9860381)+(y[i-1]*y[i-2]*89012%9860381))%9860381;
        z[i]=(x[i]*90123+y[i])%8475871+1;
    }
    for(LL i=0; i<n; i++)
        for(LL j=0; j<n; j++)
        {
            if(i==j)
                dis[i][j]=0;
            else
                dis[i][j]=z[i*n+j];
        }
}

int main()
{
    while(~scanf("%lld%lld%lld%lld%lld%lld",&n,&m,&x[0],&x[1],&y[0],&y[1]))
    {
        init();
        dijkstra();
        solve();
    }
    return 0;
}

总结:为什么我理解的意思就和正解不一样,,还是英语太渣!
认真读题!看不懂的单词就查字典!wrong多次后必须要重新读题,判断是否理解错误题意

  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值